Attribute VB_Name = "MNIST"
Option Explicit

' VXeŇoߎ(~b)𓾂܂B
Declare PtrSafe Function GetTickCount Lib "kernel32" () As Long

' j[lbg[Ñ^Cv
Enum NetworkType
    Simple = 1  ' S
    CNN = 2     ' ݍ
    RNN = 3     ' ċA^
    LSTM = 4    ' EZL
End Enum

' SinglẽoCgTCY
Public Const SizeOfSingle As Long = 4

' DoublẽoCgTCY
Public Const SizeOfDouble As Long = 8

' foCX
Public Dev As Device

' j[lbg[Ñ^Cv
Public NetType As NetworkType

' G|bN̐
Public EpochSize As Long

' G|bÑCfbNX
Public EpochIdx As Long

' ~job`̃CfbNX
Public MiniBatchIdx As Long

' C[̔z
Public Layers() As Layer

' ŏ̃C[
Public FirstLayer As Layer

' Ō̃C[
Public LastLayer As Layer

' ̓xNg̎
Public DomainLen As Long

' o̓xNg̎
Public RangeLen As Long

' s~tO
Public StopFlag As Boolean

' 𐔂̔z
Public CorrectAns() As Long

' 𐔂̃Ot̃f[^n
Public CorrectChartSeries As Series

' ODoEvents̎ ( t[YԂ邽 )
Public LastDoEventsTick As Long


'------------------------------ g[jO f[^

' ob`TCY
Public TrainBatchSize As Long

' f[^
Public TrainCnt As Long

' ̓xNg
Public TrainX() As Single

' o̓xNg
Public TrainY() As Single

' x
Public TrainLabel() As Byte


'------------------------------ eXg f[^

' ob`TCY
Public TestBatchSize As Long

' f[^
Public TestCnt As Long

' ̓xNg
Public TestX() As Single

' o̓xNg
Public TestY() As Single

' x
Public TestLabel() As Byte


' zɗvfǉ܂B
Public Sub AddArray(arr As Variant, x As Variant)
    If Not ValidArray(arr) Then
        ' Eraseꂽꍇ
    
        ReDim arr(0)
    Else
        ' LȔz̏ꍇ
        
        ReDim Preserve arr(UBound(arr) + 1)
    End If
    
    arr(UBound(arr)) = x
End Sub

' oCgz̎w肵ʒu̐l𓾂܂B
Public Function BytesToInt(v() As Byte, offset As Long) As Long
    BytesToInt = v(offset) * &H1000000 + v(offset + 1) * &H10000 + v(offset + 2) * &H100& + v(offset + 3)
End Function

'  (0, all_count-1)͈̔͂Asample_count̐𔲂oāA̔zԂ܂B
Public Function RandomSampling(all_count As Long, sample_count As Long) As Long()
    Dim i As Long
    
    ReDim ret(sample_count - 1) As Long

    ReDim numbers(all_count - 1) As Long
    For i = 0 To all_count - 1
        numbers(i) = i
    Next

    For i = 0 To sample_count - 1
        Dim n As Long: n = CLng(Rnd * 1024 * 1024 * 1024) Mod (all_count - i)

        ret(i) = numbers(n)
        numbers(n) = numbers(all_count - i - 1)
    Next

    'For i As Long = 0 To sample_count - 1
    '    For j As Long = i + 1 To sample_count - 1
    '        Debug.Assert(ret(i) <> ret(j))
    '    Next
    'Next

    RandomSampling = ret
End Function

' EraseĂȂzȂTrueԂ܂B
Public Function ValidArray(x As Variant) As Boolean
    Dim n As Long: n = -1
    On Error Resume Next
    n = UBound(x)
    Err.Clear
    ValidArray = (n <> -1)
End Function

' V[gɃbZ[W\܂B
Public Sub Msg(row, col, s As String)
    ThisWorkbook.ActiveSheet.Cells(row, col) = s
End Sub

' t@CoCgzǂݍ݂܂B
Public Function ReadAllBytes(path As String) As Byte()
    Dim buf() As Byte
    
    Open path For Binary As #1
    ReDim buf(LOF(1))
    Get #1, , buf
    Close #1
    
    ReadAllBytes = buf
End Function

' MNIST̃f[^t@Cǂݍ݂܂B
Public Sub ReadMNIST()
    Dim k As Long: k = InStrRev(ThisWorkbook.FullName, "\")
    Dim mnist_dir As String: mnist_dir = Left(ThisWorkbook.FullName, k) + "MNIST\"

    Dim buf() As Byte, i As Long, j As Long, idx As Long
    
    ' g[jO f[^̓͒l̃t@CoCgzǂݍ݂܂B
    buf = ReadAllBytes(mnist_dir + "train-images.idx3-ubyte")

    ' g[jO f[^̐
    TrainCnt = BytesToInt(buf, 4)
    
    ' 摜̍
    Dim img_h As Long: img_h = BytesToInt(buf, 8)
    
    ' 摜̕
    Dim img_w As Long: img_w = BytesToInt(buf, 12)

    ' ̓xNg̎
    DomainLen = img_h * img_w
    
    ' o̓xNg̎
    RangeLen = 10

    ReDim TrainX(TrainCnt - 1, DomainLen - 1)
    idx = 0
    ' ׂẴg[jO f[^ɑ΂
    For i = 0 To TrainCnt - 1
    
        '
        For j = 0 To DomainLen - 1
            TrainX(i, j) = buf(16 + idx) / 256!
            idx = idx + 1
        Next
    Next


    ' g[jO f[^̏o͒l̃t@CoCgzǂݍ݂܂B
    buf = ReadAllBytes(mnist_dir + "train-labels.idx1-ubyte")
    ReDim TrainLabel(TrainCnt - 1)
    'Array.Copy(buf, 8, TrainLabel, 0, TrainCnt)
    
    ' ׂẴg[jO f[^ɑ΂
    For i = 0 To TrainCnt - 1
        TrainLabel(i) = buf(8 + i)
    Next


    ' eXg f[^̓͒l̃t@CoCgzǂݍ݂܂B
    buf = ReadAllBytes(mnist_dir + "t10k-images.idx3-ubyte")
    TestCnt = BytesToInt(buf, 4)
    ReDim TestX(TestCnt - 1, DomainLen - 1)
    
    idx = 0
    For i = 0 To TestCnt - 1
        For j = 0 To DomainLen - 1
            TestX(i, j) = buf(16 + idx) / 256!
            idx = idx + 1
        Next
    Next


    ' eXg f[^̏o͒l̃t@CoCgzǂݍ݂܂B
    buf = ReadAllBytes(mnist_dir + "t10k-labels.idx1-ubyte")
    ReDim TestLabel(TestCnt - 1)
    'Array.Copy(buf, 8, TestLabel, 0, TestCnt)
    For i = 0 To TestCnt - 1
        TestLabel(i) = buf(8 + i)
    Next
End Sub

' ׂẴC[̃蓖āAC[̓o͂܂B
Sub AllocateConnectLayers(batch_size As Long)
    Dim i As Long
    
    ' C[Allocate\bhł͓͂̃Əo͂̔̃͊蓖Ă܂B
    ' ͂̃͒ÕC[̏o͂̃ƓAo͂̔̃͒̃C[̓͂̔̃ƓłB
    ' Aŏ̃C[ł͓͂̃蓖āAŌ̃C[ł͏o͂̔̃蓖Ă܂B
    
    ' ŏ̃C[̓͂̃蓖Ă܂B
    Dim p As LongPtr: p = Dev.DeviceMalloc32(batch_size * DomainLen * SizeOfSingle)
    FirstLayer.SetInput (p)

    ' Ō̃C[̏o͂̔̃蓖Ă܂B
    p = Dev.DeviceMalloc32(batch_size * RangeLen * SizeOfSingle)
    LastLayer.SetOutputDelta (p)

    ' ׂẴC[ɑ΂
    For i = 0 To UBound(Layers)
        Layers(i).BatchSize = batch_size
        Layers(i).Allocate
    Next

    ' C[̓o͂܂B
    For i = 0 To UBound(Layers) - 1

        If Layers(i).GetTimeCount() = 0 Then
            Debug.Assert (Layers(i).GetOutputCount() = Layers(i + 1).GetInputCount())

            ' ̃C[̓͂́Ã݂C[̏o͂ɂ܂B(`d)
            Layers(i + 1).SetInput (Layers(i).GetOutput())

            ' ݂̃C[̏o͂̃f^́ÃC[̓͂̃f^ɂ܂B(t`d)
            Layers(i).SetOutputDelta (Layers(i + 1).GetInputDelta())
        End If

        Layers(i).ConnectLayer Layers(i + 1)
    Next
End Sub

' ~job`̃f[^Zbg܂B
Sub SetBatchData(x() As Single, batch_X() As Single, batch_Y() As Single, label() As Byte, batch_size As Long, idxes() As Long)
    Dim i As Long, batch_idx As Long
    Dim is_array As Boolean: is_array = ValidArray(idxes)
    
    ' o̓xNg̊eɑ΂
    For i = 0 To UBound(batch_Y, 1)
    
        ' ob`̊ef[^ɑ΂
        For batch_idx = 0 To UBound(batch_Y, 2)
        
            ' one-hotxNg̒lNA܂B
            batch_Y(i, batch_idx) = 0
        Next
    Next

    ' ob`̊ef[^ɑ΂
    For batch_idx = 0 To batch_size - 1
        Dim idx As Long: idx = MiniBatchIdx * batch_size + batch_idx

        If is_array Then
            ' f[^̃CfbNXw肳ꂽꍇ

            idx = idxes(idx)
        End If

        ' ̓xNg̊eɑ΂
        For i = 0 To DomainLen - 1
            
            ' ̓xNg̒lZbg܂B
            batch_X(i, batch_idx) = x(idx, i)
        Next

        ' o͂ one-hotxNg̒lZbg܂B
        batch_Y(label(idx), batch_idx) = 1
    Next
End Sub

' ֐̔
Sub CostDerivative(cost_derivative() As Single, last_y() As Single, batch_Y() As Single)
    Dim i As Long, batch_idx As Long
    
    For i = 0 To UBound(last_y, 1)
        For batch_idx = 0 To UBound(last_y, 2)
            cost_derivative(i, batch_idx) = last_y(i, batch_idx) - batch_Y(i, batch_idx)
        Next
    Next
End Sub

' ֐
Function Cost(cost_derivative() As Single) As Single
    Dim i As Long, batch_idx As Long, cd As Single
    Dim sum As Double: sum = 0
    
    ' o̓xNg̊eɑ΂
    For i = 0 To UBound(cost_derivative, 1)
    
        ' ob`̃f[^ɑ΂
        For batch_idx = 0 To UBound(cost_derivative, 2)
        
            ' ֐̔
            cd = cost_derivative(i, batch_idx)
            
            ' ֐̔̓Z܂B
            sum = sum + cd * cd
        Next
    Next

    Dim size As Long: size = (UBound(cost_derivative, 1) + 1) * (UBound(cost_derivative, 2) + 1)
    Cost = CSng(sum / size)
End Function

' ~job`ƂɃp[^XV܂B
Sub UpdateMiniBatch(batch_X() As Single, batch_Y() As Single, last_y() As Single, cost_derivative() As Single)
    Dim i As Long
    Dim batch_size As Long: batch_size = TrainBatchSize
    
    ' ͂Zbg܂B
    FirstLayer.SetInputData batch_X

    ' `ďvZ܂B
    For i = 0 To UBound(Layers)
        Layers(i).Forward
    Next
    
    ' foCX̓Ƃ܂B
    Dev.DeviceSynchronize

    ' o͂𓾂܂B
    LastLayer.GetOutputData last_y
            
    ' ֐̔vZ܂B
    CostDerivative cost_derivative, last_y, batch_Y

    ' ֐vZ܂B
    Dim cost1 As Single: cost1 = Cost(cost_derivative)

    ' yZbg܂B
    LastLayer.SetOutputDeltaData cost_derivative

    ' 덷t`ďvZ܂B
    For i = UBound(Layers) To 0 Step -1
        Layers(i).Backward
    Next
    
    ' foCX̓Ƃ܂B
    Dev.DeviceSynchronize

    ' p[^XV܂B
    For i = UBound(Layers) To 0 Step -1
        Layers(i).UpdateParameter
    Next

    ' foCX̓Ƃ܂B
    Dev.DeviceSynchronize
End Sub

' ől̃CfbNX̃CfbNXƓ𓾂܂B
Function ArgMax(result_Y() As Single, batch_size As Long, arg_max() As Byte, label() As Byte) As Long
    Dim batch_idx As Long, i As Long
    Dim eq_cnt As Long: eq_cnt = 0

    ' ob`ׂ̂Ẵf[^ɑ΂
    For batch_idx = 0 To batch_size - 1

        Dim max_val As Single: max_val = -10000
        Dim max_idx As Long: max_idx = 0
        
        ' o͂̊eɑ΂
        For i = 0 To RangeLen - 1
            Dim val As Single: val = result_Y(i, batch_idx)
            If max_val < val Then
                ' ݂܂ł̍ől傫ꍇ

                ' őlƍől̃CfbNXXV܂B
                max_val = val
                max_idx = i
            End If
        Next

        ' ől̃CfbNXZbg܂B
        arg_max(batch_idx) = max_idx

        If max_idx = label(MiniBatchIdx * batch_size + batch_idx) Then
            ' ől̃CfbNX̃CfbNXƓꍇ
            
            ' 𐔂Z܂B
            eq_cnt = eq_cnt + 1
        End If
    Next

    ' 𐔂Ԃ܂B
    ArgMax = eq_cnt
End Function

' eXg f[^̕]܂B
Function Evaluate(batch_X() As Single, batch_Y() As Single, last_y() As Single, batch_size As Long, arg_max() As Byte, label() As Byte) As Long
    Dim i As Long
    
    ' ͂Zbg܂B
    FirstLayer.SetInputData batch_X

    ' `ďvZ܂B
    For i = 0 To UBound(Layers)
        Layers(i).Forward
    Next

    ' o͂𓾂܂B
    LastLayer.GetOutputData last_y

    ' ől̃CfbNX̃CfbNXƓ𓾂܂B
    Dim eq_cnt As Long: eq_cnt = ArgMax(last_y, batch_size, arg_max, label)

    Evaluate = eq_cnt
End Function

' ׂẴC[̃܂B
Sub FreeLayers()
    Dim i As Long
    
    For i = 0 To UBound(Layers)
        Layers(i).Free
    Next

    Dev.DeviceFree (FirstLayer.GetInput())
    Dev.DeviceFree (LastLayer.GetOutputDelta())
End Sub

' t[YԂɂȂȂ悤DoEventss܂B
Sub HandleDoEvents()
    If LastDoEventsTick = 0 Then
        ' ŏ̏ꍇ
        
        LastDoEventsTick = GetTickCount
    Else
        ' 2ڈȍ~̏ꍇ
        
        Dim t As Long: t = GetTickCount() - LastDoEventsTick
        If 500 < t Then
            ' O񂩂500~bo߂ꍇ
        
            DoEvents
            LastDoEventsTick = GetTickCount
        End If
    End If
End Sub

' mIz~@ (stochastic gradient descent, SGD)
Sub SGD()
    ' g[jO f[^̃ob`TCY
    Dim train_batch_cnt As Long: train_batch_cnt = TrainCnt / TrainBatchSize
    
    ' eXg f[^̃ob`TCY
    Dim test_batch_cnt As Long: test_batch_cnt = TestCnt / TestBatchSize

    ' g[jO f[^̓͒l
    ReDim train_batch_X(DomainLen - 1, TrainBatchSize - 1) As Single
    
    ' g[jO f[^̐̏o͒l
    ReDim train_batch_Y(RangeLen - 1, TrainBatchSize - 1) As Single
    
    ' g[jO f[^̌vZo͒l
    ReDim train_last_Y(RangeLen - 1, TrainBatchSize - 1) As Single

    ' ֐̔
    ReDim cost_derivative(RangeLen - 1, TrainBatchSize - 1) As Single

    ' eXg f[^̓͒l
    ReDim test_batch_X(DomainLen - 1, TestBatchSize - 1) As Single
    
    ' eXg f[^̐̏o͒l
    ReDim test_batch_Y(RangeLen - 1, TestBatchSize - 1) As Single
    
    ' eXg f[^̌vZo͒l
    ReDim test_last_Y(RangeLen - 1, TestBatchSize - 1) As Single

    ReDim test_arg_max(TestBatchSize) As Byte

    ' ̓f[^̃CfbNX̔z
    Dim idxes() As Long

    ' ÕbZ[W\̎
    Dim last_msg_tick As Long: last_msg_tick = 0

    ' G|bÑ[v
    For EpochIdx = 0 To EpochSize - 1

        ' [0, TrainCnt-1]͈̔͂̐_ɕוς܂B
        idxes = RandomSampling(TrainCnt, TrainCnt)

        ' ׂẴC[̃蓖āAC[̓o͂܂B
        AllocateConnectLayers (TrainBatchSize)

        ' g[jO f[^̃~job`̃[v
        For MiniBatchIdx = 0 To train_batch_cnt - 1

            ' ~job`̃f[^Zbg܂B
            SetBatchData TrainX, train_batch_X, train_batch_Y, TrainLabel, TrainBatchSize, idxes

            ' ~job`ƂɃp[^XV܂B
            UpdateMiniBatch train_batch_X, train_batch_Y, train_last_Y, cost_derivative
                        
            If StopFlag Then
                ' ~{^ꂽꍇ
                
                Exit For
            End If
            
            If 3000 < GetTickCount() - last_msg_tick Then
                ' ÕbZ[W\3bo߂ꍇ
            
                last_msg_tick = GetTickCount()
                Msg 1, 1, "~job` = " + Format(MiniBatchIdx) + " / " + Format(train_batch_cnt)
            End If
            
            ' t[YԂɂȂȂ悤DoEventss܂B
            HandleDoEvents
        Next

        ' ׂẴC[̃܂B
        FreeLayers

        ' ̓f[^̃CfbNX̔z폜܂B
        Erase idxes
        
        If StopFlag Then
            ' ~{^ꂽꍇ
            
            Exit For
        End If

        ' ׂẴC[̃蓖āAC[̓o͂܂B
        AllocateConnectLayers (TestBatchSize)

        Dim eq_cnt_sum As Long: eq_cnt_sum = 0
                
        ' eXg f[^̃~job`̃[v
        For MiniBatchIdx = 0 To test_batch_cnt - 1

            ' ~job`̃f[^Zbg܂B
            SetBatchData TestX, test_batch_X, test_batch_Y, TestLabel, TestBatchSize, idxes

            ' eXg f[^̕]܂B
            Dim eq_cnt As Long: eq_cnt = Evaluate(test_batch_X, test_batch_Y, test_last_Y, TestBatchSize, test_arg_max, TestLabel)
            eq_cnt_sum = eq_cnt_sum + eq_cnt
        Next
        Msg 2, 1, "G|bN = " + Format(EpochIdx) + " :  = " + Format(eq_cnt_sum) + " / " + Format(TestCnt)
        
        ' 𐔂̔zɒǉ܂B
        AddArray CorrectAns, eq_cnt_sum
        
        ' 𐔂̃Ot̕\XV܂B
        CorrectChartSeries.Values = CorrectAns
        
        FreeLayers
    Next
End Sub

' fB[v[jÕC[`
Public Sub DeepLearning()
    Msg 2, 1, "Jn܂B"
    
    '---------------------------------------- ϐ̃Zbg
    
    ' s~tONA܂B
    StopFlag = False

    ' G|bN̐
    EpochSize = 100
    
    ' g[jO f[^̃ob`TCY
    TrainBatchSize = 10
    
    ' eXg f[^̃ob`TCY
    TestBatchSize = 20

    
    '---------------------------------------- foCX̏ĂAC[쐬IuWFNg܂B

    Dim layer_factory As LayerFactoryF:

' CUDAgꍇ͈ȉUseCUDATrueɂ܂B
#Const UseCUDA = False

#If UseCUDA Then
    ' CUDAgꍇ

    ' foCX̏܂B
    Set Dev = New DeviceCuda
    Dev.DeviceInit
    
    ' C[쐬IuWFNg܂B
    Set layer_factory = New LayerFactoryCudaF
#Else
    ' CUDAgȂꍇ
    
    ' foCX̏܂B
    Set Dev = New Device
    Dev.DeviceInit
 
    ' C[쐬IuWFNg܂B
    Set layer_factory = New LayerFactoryF
#End If
    
    
    '---------------------------------------- j[lbg[N̏
    
    NetType = NetworkType.Simple
    NetType = NetworkType.CNN

    Select Case NetType
    Case NetworkType.Simple
        ' SC[݂̂̏ꍇ
        
        ' 2w̃C[܂B
        ReDim Layers(1)
        
        Set Layers(0) = layer_factory.MakeFullyConnectedLayer(28 * 28, 30)
        Set Layers(1) = layer_factory.MakeFullyConnectedLayer(30, 10)

    Case NetworkType.CNN
        ' ݍ݃j[lbg[N̏ꍇ
        
        ' 4w̃C[܂B
        ReDim Layers(3)
        
        Set Layers(0) = layer_factory.MakeConvolutionalLayer(28, 28, 5, 5)        ' ݍ݃C[
        Set Layers(1) = layer_factory.MakeMaxPoolingLayer(24, 24, 5, 2)           ' }bNXv[O C[
        Set Layers(2) = layer_factory.MakeFullyConnectedLayer(12 * 12 * 5, 100)   ' SC[
        Set Layers(3) = layer_factory.MakeFullyConnectedLayer(100, 10)            ' SC[
    End Select

    ' wKZbg܂B
    Dim i As Long
    Dim learning_rate As Single: learning_rate = 1#
    For i = 0 To UBound(Layers)
        Layers(i).LearningRate = learning_rate / TrainBatchSize '3.0f
    Next

    ' ŏ̃C[
    Set FirstLayer = Layers(0)
    
    ' Ō̃C[
    Set LastLayer = Layers(UBound(Layers))

    ' MNIST̃f[^t@Cǂݍ݂܂B
    ReadMNIST
    

    '---------------------------------------- C̊wK
        
    ' mIz~@
    SGD


    '---------------------------------------- I
    
    ' C[폜܂B
    For i = 0 To UBound(Layers)
        Layers(i).Destroy
    Next
    Erase Layers
    
    ' foCXI܂B
    Dev.DeviceEnd

    Msg 2, 1, "I܂B"
End Sub

' ~{^̃NbN
Sub StopButton_OnAction()
    ' s~tOIɂ܂B
    StopFlag = True
End Sub

' ~{^܂B
Sub MakeStopButton()
    If ActiveSheet.Buttons.Count() <> 0 Then
        ' {^쐬ς݂̏ꍇ
        
        ' 폜܂B
        ActiveSheet.Buttons.Delete
    End If
    
    ' ~{^܂B
    With ActiveSheet.Buttons.Add(Range("B5").Left, Range("B5").Top, Range("B5:C6").Width, Range("B5:C6").Height)
    
        ' NbN̏w肵܂B
        .OnAction = "StopButton_OnAction"
        
        ' ^CgZbg܂B
        .Characters.text = "~"
    End With
End Sub

' 𐔂̃Ot܂B
Sub MakeChart()
    If ActiveSheet.ChartObjects.Count() <> 0 Then
        ' Ot쐬ς݂̏ꍇ
        
        ' 폜܂B
        ActiveSheet.ChartObjects.Delete
    End If
    
    ' 𐔂̃Ot܂B
    With ActiveSheet.ChartObjects.Add(250, 20, 300, 200).Chart
        ' c_̃Otɂ܂B
        .ChartType = xlColumnClustered
        
        ' Ot̃f[^n܂B
        Set CorrectChartSeries = .SeriesCollection.NewSeries
        
        ' Ot̃^CgZbg܂B
        CorrectChartSeries.name = ""
    End With
    
    ' 𐔂̔zNA܂B
    If ValidArray(CorrectAns) Then
        ' EraseĂȂꍇ
        
        Erase CorrectAns
    End If
End Sub

' MNIST̃eXg
Public Sub TestMNIST()
    ' ~{^܂B
    MakeStopButton
    
    ' 𐔂̃Ot܂B
    MakeChart
    
    ' fB[v[jÕC[`
    DeepLearning
End Sub
